<template>
  <div
    class="answertype"
    type="checkbox"
    v-bind:style="scrollListHeight"
  >
    <label
      class="listing answer"
      type="checkbox-answer"
      v-for="(answeroption, answeroptionIndex) in answer.options"
      :key="answeroptionIndex"
      v-bind:for="answer.id+'-'+answeroptionIndex"
      v-bind:id="'l-'+answer.id+'-'+answeroptionIndex"
      v-bind:class="{checked: isChecked(answeroptionIndex)}"
    >
      <input
        type="checkbox"
        v-bind:name="answer.id"
        v-bind:value="answer.id+'-'+answeroptionIndex"
        v-bind:id="answer.id+'-'+answeroptionIndex"
        v-bind:checked="isChecked(answeroptionIndex)"
        v-on:change="answerChanged($event.target.value)"
      />
      <answertype
        type="answertype"
        v-bind:answer="answeroption"
        v-bind:answerset="answerset"
        v-on:changedAnswer="changedAnswer"
      ></answertype>
      <br/>
    </label>
  </div>
</template>

<script>
  export default {
    name: 'checkbox',
    props: ['answer', 'answerset'],
    computed: {
      answerObject: function () {
        const index = this.answerset.findIndex(x => x.id === this.answer.id);

        if (index === -1) {
          return {id: this.answer.id, lastChange: -1, value: []};
        }
        else {
          return this.answerset[index];
        }
      },
      scrollListHeight: function () {
        return {
          'max-height': 0.4 * window.innerHeight + 'px',
        }
      },
    },
    methods: {
      toggleChecked: function (labelId) {
        let inputLabel = document.getElementById(labelId);
        inputLabel.classList.toggle("checked");
      },
      /** Emitted when changes of answers are logged in a child component.
       * Updates answerObject and passes change event through to parent.
       * @param answerObject from capsuled answer
       */
      changedAnswer: function (answerObject) {
        /* refactoring solution for this function in next version.*/
        const lastOption = this.answer.options.length - 1;
        if (!this.isChecked(lastOption)) {
          this.answerChanged(`${this.answer.id}-${lastOption}`);
        }

        this.$emit('changedAnswer', answerObject);
      },
      /**
       * updates saved Answer on change event.
       * updates the List of answers and informs parent of change.
       * @param value new Answer
       * @returns {answerObject|{id, value}}
       */
      answerChanged: function (value) {
        let valueIndex = this.answerObject.value.findIndex(x => x === value);
        if (valueIndex === -1) {
          this.answerObject.value.push(value);
        } else {
          this.answerObject.value.splice(valueIndex, 1);
        }
        this.answerObject.lastChange = Date.now();
        this.$emit('changedAnswer', this.answerObject);
      },
      isChecked(answerIndex) {
        const index = this.answerset.findIndex(x => x.id === this.answer.id);
        const checkboxId = this.answer.id + '-' + answerIndex;
        return index !== -1 && this.answerset[index].value.findIndex(x => x === checkboxId) !== -1;
      }
    }
  };
</script>

<style scoped>
  .answertype[type="checkbox"] {
    -webkit-filter: drop-shadow(2px 2px 2px rgba(0, 0, 0, 0.5));
    filter: drop-shadow(2px 2px 2px rgba(0, 0, 0, 0.5));
    overflow: auto;
  }

  @media screen and (min-height: 700px) {
    .answertype[type="checkbox"] {
      height: inherit !important;
    }
  }

  [type="checkbox-answer"] {
    display: block;
    width: auto;
    border: none;
    text-align: left;
    padding: 1vh 2ch;
  }

  [type="answertype"] {
    display: inline;
    width: auto;
    height: auto;
    padding-left: 5px;
    background-color: transparent;
  }

  .checked {
    background-color: #43A047;
  }

  /* Screen height <= 700px */
  @media screen and (max-height: 700px) {
    [type="checkbox-answer"] {
      padding: 2vh 2ch;
    }
  }
</style>
